    surfaceScalarField muf
    (
        "muf",
        twoPhaseProperties.muf() 
      + fvc::interpolate(rho*turbulence->nut())
    );

    // Convection term to be added separately, depending on a singlePhase switch
    // HJ, 4/Aug/2008
    fvVectorMatrix UEqn
    (
        fvm::ddt(rho, U)
      - fvm::laplacian(muf, U, "laplacian(mut,U)")
      - (fvc::grad(U) & fvc::grad(muf))
    );

    Switch singlePhase(piso.lookup("singlePhase"));

    if (singlePhase)
    {
        UEqn += pos(gamma - 0.1)*fvm::div(rhoPhi, U);
//         UEqn += gamma*fvm::div(rhoPhi, U);
    }
    else
    {
        UEqn += fvm::div(rhoPhi, U);
    }

    solve
    (
        UEqn
     ==
        fvc::reconstruct
        (
            (
                fvc::interpolate(interface.sigmaK())*fvc::snGrad(gamma)
              - ghf*fvc::snGrad(rho)
              - fvc::snGrad(pd)
            )*mesh.magSf()
        )
    );

    if (singlePhase)
    {
        U *= pos(gamma - 0.1);
        U.correctBoundaryConditions();
    }
